Subject: RE: [Diffserv] Model Draft TB?

From: Shahram Davari <[email-masked]>
Date: Fri, 7 Jul 2000 12:28:59 -0700

Hi Fred,

I did more analysis of the Model draft, and I found that the conformance
definition of TB in the draft is also incorrect. the Model draft says:

" interval = committed_burst/mean_rate, ....A data stream is said to conform
to a simple token bucket if the switch receives at most the "burst_size" of
data in any time interval of length "interval"".

Let's assume:

T = interval
CBS = committed_burst 
R = mean_rate
B= token depth
MTU= Max. packet size

According to Model draft we have:

T = CBS/R

Considering the Negative TB in the draft, assume a line rate which is much
higher than the token rate, and that the TB is initially full. In this case
we could receive an instantaneous burst of "Burst=B+MTU", which will pass
through the TB. Then the TB would not accept any packet for a period of
(T1=MTU/R), and after that assume that we receive small packets of rate R,
with regular intervals that pass through. Same as figure below:

Burst=           small packet         
MTU+B             of rate "R"           
  |            |    |    |   |  
  v            V    V    V   V           
  ----------------------------
  <-----------><-------------->
     T1=MTU/R       T2=(T-T1)
  <---------------------------->
                T

Let's compute the committed Burst size:

CBS = Burst + R.T2
CBS = Burst + R.(T-T1)
CBS = Burst + R.T - R.T1   
CBS = Burst + CBS - R.T1      //substitute from T = CBS/R
Burst = R.T1 = R. MTU/R = MTU
B+MTU = MTU
=> B=0

As you can see the negative TB is only compliant with the definition when
B=0 (i.e., when token bucket depth is zero). In other words, in order to
comply to your definition, the silent time "T1" must be equal to the time
that it takes to accumulate enough tokens equal to the Burst size, which is
impossible unless we don't accept any packet until the TB is full again.

Also a Positive TB is never compliant to this definition.

My suggestion is that, let's change the definition of the TB to the one in
RFC2211/2212:

" Over all time periods, the amount of data sent should not exceed RT+B,
where R and B are the token bucket parameters and T is the length of the
time period."

Using this conformance definition, both negative and positive TBs would both
be compliant.

Also as I mentioned in my previous emails, since negative TB has a few
problems including the granularity problem, I suggest changing it to
positive TB. 

Regards,
-Shahram

>-----Original Message-----
>From: Fred Baker [mailto:[email-masked]]
>Sent: Thursday, June 29, 2000 3:31 PM
>To: Shahram Davari
>Subject: RE: [Diffserv] Model Draft TB?
>
>
>At 09:03 AM 6/29/00 -0700, Shahram Davari wrote:
>>But we should design it with valid data, and valid 
>justification and be
>>consistent to other IETF documents and standards.
>
>No problem. Can you interact with the design and tell us what 
>we need to fix?
>

_______________________________________________
diffserv mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/diffserv
Archive: http://www-nrg.ee.lbl.gov/diff-serv-arch/